#include <Arduino.h>  // for type definitions
#include <Wire.h>
//tested FM24C16B

template <class T> int FRAM_WriteAnything(int dd, int ee, const T& value)
{
  const byte* p = (const byte*)(const void*)&value;
  unsigned int i;
  byte devaddr = dd | ((ee >> 8) & 0x07);
  for (i = 0; i < sizeof(value); i++)
  {
    Wire.beginTransmission(devaddr);
    Wire.write(int(ee++));
    Wire.write(int(*p++));
    Wire.endTransmission();
  }
  return i;
}

template <class T> int FRAM_ReadAnything(int dd, int ee, T& value)
{
  byte* p = (byte*)(void*)&value;
  unsigned int i;
  byte rdata = -1;
  byte devaddr = dd | ((ee >> 8) & 0x07);
  for (i = 0; i < sizeof(value); i++)
  {
    Wire.beginTransmission(devaddr);
    Wire.write(int(ee++));
    Wire.endTransmission();
    Wire.requestFrom(int(devaddr), 1);
    if (Wire.available()) {
      rdata = Wire.read();
    }
    *p++ = rdata;
    }
  return i;
}